### 页面操作不完全指南

#### 项目
##### 项目路径和gulp之间的关系
项目路径是整个项目的根目录，当未配置时，gulp是不会执行的。配置后， 生成的文件在 项目路径 + gulp配置项中buildPath 下。

#### 两种情况下API配置
##### 通过URL判断目标API
此时，API名称和URL必须相同，API识别路径为空即可
##### URL固定，通过POST、GET、PUT、DELETE等上传的参数组成的对象进行判断目标API
URL填写固定值即可，在API路径中填写上传参数组成的对象键名，在API名称中填写对应的键值
如POST-->/api参数：
~~~javascript
 {
   func: "someApi",
   app: 80,
   params: "{\"id\": 3333}"
 }
~~~
我们需要根据上传的func进行判断，则填写如下：
~~~
api名称： someApi
url: /api
请求方法： POST 
识别路径： func
~~~

#### 配置返回的数据
##### 仅需要添加一个数据
~~~
判断条件： 
输入参数模板： {}
输出参数模板： {}
mock数据： 数据
~~~

##### 根据上传参数不同返回不同的数据
如POST-->/api参数：
~~~javascript
 {
   func: "someApi",
   app: 80,
   params: "{\"type\": 0}"
 }
~~~
我们需要根据params中type字段不同返回不同的数据
如type === 0 我们返回 {code: 0, data: {tips: "哈哈，成功了"}}
其他情况下返回 {code: 0, data: {tips: "这是主干数据"}}
我们新建一个分支，各项填写如下：
~~~
判断条件： 
输入参数模板： {}
输出参数模板： {}
mock数据： {code: 0, data: {tips: "这是主干数据"}}
~~~
点击新建分支，添加一个判断数据的分支
~~~
判断条件： params.type === 0
输入参数模板： {func:{type: 'string'}, params: {type: 'object', child: {type: {type: 'number'}}}}
输出参数模板： {}
mock数据： {code: 0, data: {tips: "哈哈，成功了"}}
~~~

判断条件的书写规则是：
所有从URL上传的参数根据输入参数模板进行格式化后，直接将各参数传给该条件。该判断条件实质上是函数，当脚本中不含有return 时，会自动加上return 
return 的值为真，表示符合条件，会返回该api的值。当脚本中含有return 时，直接执行该判断脚本，返回值为真则返回该api的值
声明新变量或复杂的计算也可写在该脚本中


#### 设为当前值、错误、随机、清除的用法
点击设为当前值后，该分支的值会被设定为api的固定值，不管请求参数如何，均返回该值
错误值是根据项目的错误信息模板，直接生成对应的错误信息，该API会一直返回该值
随机是根据输出参数模板生成随机的数据，可使用faker.js中定义的类型进行指定。
清除会清除上述三种状态
